﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace DesiredPortableClassLibrary
{
    public class DesiredClass
    {
        private string _name;

        public static bool IsWeb()
        {
            return ((HttpContext.Current != null) && (HttpRuntime.AppDomainAppId != null));
        }
        
        public virtual string Name 
        { 
            get
            {
                return IsWeb()?System.Web.HttpContext.Current.Session["Name"].ToString():_name;
            }
            set
            {
                if (IsWeb())
                {
                    System.Web.HttpContext.Current.Session.Add("Name", value);
                }
                else
                {
                    _name = value;
                }
            }
        }

        public virtual string GetHello()
        {
            return "Hello world, " + Name + "!";
        }
    }
}